######################################################################
# pyukiwiki.skin.cgi - This is PyukiWiki, yet another Wiki clone.
# $Id: pyukiwiki.skin.cgi,v 1.33 2006/03/17 14:00:11 papu Exp $
#
# "PyukiWiki" version 0.1.6 $$
# Copyright (C) 2004-2006 by Nekyo.
# http://nekyo.hp.infoseek.co.jp/
# Copyright (C) 2005-2006 PyukiWiki Developers Team
# http://pyukiwiki.sourceforge.jp/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sourceforge.jp/
# License: GPL2 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return:LF Code=EUC-JP 1TAB=4Spaces
######################################################################
# Skin.ja:PyukiWikiɸ
# Skin.en:PyukiWiki Default
######################################################################

sub skin {
	my ($pagename, $body, $is_page, $bodyclass, $editable, $admineditable, $basehref, $lastmod) = @_;

	my($page,$message,$errmessage)=split(/\t/,$pagename);	
	my $cookedpage = &encode($page);
	my $cookedurl=&make_cookedurl($cookedpage);
	my $escapedpage = &htmlspecialchars($page);
	my $escapedpage_short=$escapedpage;
	$escapedpage_short=~s/^.*\///g if($::short_title eq 1);
	my $HelpPage = &encode($::resource{help});
	my $htmlbody;
	my ($title,$headerbody,$menubarbody,$footerbody,$notesbody);
	my $headermenubody;

	# CSS
	if($::lang eq 'ja') {
		$csscharset=qq( charset="Shift_JIS");
	}
	if($::use_blosxom eq 1) {
		$::IN_HEAD.=<<EOD;
<link rel="stylesheet" href="$::skin_url/blosxom.css" type="text/css" media="screen"$csscharset />
EOD
	}

	# <title>
	if($::wiki_title ne '') {
		$title="$::wiki_title - ";
	}

	if($page eq '') {
		$title_tag="$title$message";
	} else {
		$title_tag="$title$escapedpage @{[&htmlspecialchars(&get_subjectline($page))]}";
	}

	# MenuBar, :Header, :FooterHTML
	if($is_page || $::allview eq 1) {
		$headerbody=&print_content($::database{$::Header}, $::form{mypage})
			if(&is_exist_page($::Header));
		$::pushedpage = $::form{mypage};	# push;
		$::form{mypage}=$::MenuBar;
		$menubarbody=&print_content($::database{$::MenuBar}, $::pushedpage)
			if(&is_exist_page($::MenuBar));
		if ($::HeaderMenu ne '') {
			$::form{mypage}=$::HeaderMenu;
			$headermenubody=&print_content($::database{$::HeaderMenu}, $::pushedpage)
				if(&is_exist_page($::HeaderMenu));
		}
		$::form{mypage}=$::pushedpage;	# pop;
		$::pushedpage="";
		$footerbody=&print_content($::database{$::Footer}, $::form{mypage})
			if(&is_exist_page($::Footer));
	}

	# HTML
	if (@::notes) {
		$notesbody.= << "EOD";
<div id="note">
<hr class="note_hr" />
EOD
		my $cnt = 1;
		foreach my $note (@::notes) {
			$notesbody.= << "EOD";
<a id="notefoot_$cnt" href="@{[&make_cookedurl($::form{mypage})]}#notetext_$cnt" class="note_super">*$cnt</a>
@{[$::notesview ne 0 ? qq(<span class="small">) : '']}@{[$note]}@{[$::notesview ne 0 ? qq(</span>) : '']}
<br />
EOD
			$cnt++;
		}
		$notesbody.="</div>\n";
	}

	# HTML <head></head> 顢󥯤ޤ
	$htmlbody=<<"EOD";
$::dtd
<title>$title_tag</title>
@{[$basehref eq '' ? '' : qq(<base href="$basehref" />)]}
<link rel="stylesheet" href="$::skin_url/$::skin{default_css}" type="text/css" media="screen"$csscharset />
<link rel="stylesheet" href="$::skin_url/$::skin{print_css}" type="text/css" media="print"$csscharset />
@{[$::AntiSpam ne "" ? '' : qq(<link rev="made" href="mailto:$::modifier_mail" />)]}
<link rel="top" href="$::script" />
<link rel="index" href="$::script?cmd=list" />
@{[$::use_SiteMap eq 1 ? qq(<link rel="contents" href="$::script?cmd=sitemap" />) : '']}
<link rel="search" href="$::script?cmd=search" />
<link rel="help" href="$::script?$HelpPage" />
<link rel="author" href="$::modifierlink" />
<meta name="description" content="$title$escapedpage @{[&htmlspecialchars(&get_subjectline($page))]}" />
<meta name="author" content="$::modifier" />
<meta name="copyright" content="$::modifier" />
<script type="text/javascript" src="$::skin_url/$::skin{common_js}"></script>
$::IN_HEAD</head>
EOD


	$htmlbody.=<<EOD;
<body class="$bodyclass" style="background-image: url($::image_url/head_bg.png); background-repeat: no-repeat; background-attachment: scroll;" >
<div id="container">
<div id="head">

<table id="header_table" border="0" cellpadding="0" cellspacing="0">
<colgroup valign="top" align="left">
<colgroup valign="top" align="right">
<tr class="header_tr">
<td class="header_td">
<div id="header">
@{[ $::last_modified == 1
  ? qq(<div id="lastmodified">$::lastmod_prompt $lastmod</div>)
  : q()
]}
EOD
# <a href="$::modifierlink"><img id="logo" src="$::logo_url" width="$::logo_width" height="$::logo_height" alt="$::logo_alt" title="$::logo_alt" /></a>


	# ڡȥ롢åɽ
	if($errmessage ne '') {
		$htmlbody.=<<EOD;
<span class="wiki_title">$wiki_title</span>
<h1 class="error">$errmessage</h1>
EOD
	} elsif($page ne '') {
		if ($page eq $::FrontPage) {
			$htmlbody.=<<EOD;
<span class="wiki_title"></span>
<h1 class="title">$wiki_title</h1>
EOD
		} else {
			$htmlbody.=<<EOD;
<span class="wiki_title">$wiki_title</span>
<h1 class="title"><a
    title="$::resource{searchthispage}"
    href="$::script?cmd=search&amp;mymsg=$cookedpage">$escapedpage_short</a>@{[$message eq '' ? '' : "&nbsp;$message"]}</h1>
EOD
#<span class="small">@{[&topicpath]}</span>
		}
	} else {
		$htmlbody.=<<EOD;
<span class="wiki_title">$wiki_title</span>
<h1 class="title">$message</h1>
EOD
	}

	# topicpath & ʥӥɽ
	$htmlbody.=<<EOD;
</div>
<div id="topicpath">
(@{[&topicpath]})
<br />
<br />
</div>

</td>
<td class="header_td">
<div id="navigator">
[ 
EOD
	my $flg=0;
	foreach $name (@::navi) {
		if($name eq '') {
			$htmlbody.=" ] &nbsp; [ " if($flg ne 0);
			$flg=0;
		} elsif ($name eq "top") {
			# ȥåפλ FrontPageǤʤ롼url֤褦
			if($::navi{"$name\_name"} ne '') {
				$htmlbody .= " | " if($flg eq 1);
				$flg=1;
				$htmlbody.=<<EOD;
<a title="@{[$::navi{"$name\_title"} eq '' ? $::navi{"$name\_name"} : $::navi{"$name\_title"}]}" href="$::basehref">$::navi{"$name\_name"}</a>
EOD
			}
		} elsif ($::navigator4me == 0 || $name =~ /^(list|sitemap|search|recent|setting)$/) {
			if($::navi{"$name\_name"} ne '') {
				$htmlbody .= " | " if($flg eq 1);
				$flg=1;
				$htmlbody.=<<EOD;
<a title="@{[$::navi{"$name\_title"} eq '' ? $::navi{"$name\_name"} : $::navi{"$name\_title"}]}" href="$::navi{"$name\_url"}">$::navi{"$name\_name"}</a>
EOD
			}
		}
	}
	$htmlbody.=<<EOD;
]
</div>
EOD
	if ($headermenubody ne '') {
		$htmlbody .= "<div id=\"headermenu\">$headermenubody</div>";
	}

	$htmlbody.=<<EOD;
</td>
</table>
</div>
EOD

	my $menubar_pos = $::setting_cookie{menubarpos} eq '2' ? 1
					: $::setting_cookie{menubarpos} eq '1' ? 0
					: 										$::menubar_pos;

	# table
	$htmlbody.= <<"EOD";
<dfn></dfn>
<div id="content">
<table class="content_table" border="0" cellpadding="0" cellspacing="0">
@{[$headerbody ne '' ? qq(<tr><td@{[($menubarbody ne '' && $menubar_pos == 0) ? qq( colspan="2") : '']}>$headerbody</td></tr>) : '']}
  <tr class="content_tr">
EOD

	# ¦ MenuBar ɽ
	if ($menubar_pos == 0 && $menubarbody ne '') {
		$htmlbody.=<<"EOD";
    <td class="menubar" valign="top">
    <div id="menubar">
$menubarbody
    </div>
    </td>
EOD
	}

	# ƥĤɽ
	$htmlbody.= <<"EOD";
    <td class="content_td" valign="top">
      <div id="body">$body</div>@{[$::notesview eq 0 ? $notesbody : '']}
    </td>
EOD

	# ¦ MenuBar ɽ
	if ($menubar_pos != 0 && $menubarbody ne '') {
		$htmlbody.=<<"EOD";
    <td class="menubar" valign="top">
    <div id="menubar">
$menubarbody
    </div>
    </td>
EOD
	}

		$htmlbody.= <<"EOD";
  </tr>
@{[$::notesview eq 1 ? qq(<tr><td@{[$menubarbody ne '' ? qq( colspan="2") : '']}>$notesbody</td></tr>) : '']}
@{[$footerbody ne '' ? qq(<tr><td@{[$menubarbody ne '' ? qq( colspan="2") : '']}>$footerbody</td></tr>) : '']}
</table>
EOD


	# ɽ:Footerβ
	$htmlbody.=$::notesview eq 2 ? $notesbody : '';

	# եå
	$htmlbody.= <<"EOD";
</div>
<div id="foot">
<hr class="full_hr" />
EOD

	if ($::navigator4me) {
		# 񤭹߼ѥʥӥɽ
		$htmlbody.=<<EOD;
<div id="navigator2">[ 
EOD
		$flg=0;
		foreach $name (@::navi) {
			if($name eq '') {
				$htmlbody.=" ] &nbsp; [ " if($flg ne 0);
				$flg=0;
			} elsif ($name =~ /^(reload|newpage|adminedit|edit|diff|rename|attach|help)$/) {
				if($::navi{"$name\_name"} ne '') {
					$htmlbody .= " | " if($flg eq 1);
					$flg=1;
					$htmlbody.=<<EOD;
	<a title="@{[$::navi{"$name\_title"} eq '' ? $::navi{"$name\_name"} : $::navi{"$name\_title"}]}" href="$::navi{"$name\_url"}">$::navi{"$name\_name"}</a>
EOD
				}
			}
		}

	$htmlbody.=<<EOD;
]
<!-- <a href="$::script?cmd=rss10"><img src="$::image_url/rss10.png" alt="RSS" /></a> -->
EOD

	} else {
		# ɽ
		$htmlbody.= <<"EOD";
<div id="toolbar">
EOD
		if($::toolbar ne 0) {
			foreach $name (@::navi) {
				if($name eq '') {
					$htmlbody.=" &nbsp; ";
				} else {
					if(-f "$image_dir/$name.png") {
						if($::toolbar eq 2 || $::navi{"$name\_height"} ne '') {
							my $height=$::navi{"$name\_height"} eq '' ? 20 : $::navi{"$name\_height"};
							my $width=$::navi{"$name\_width"} eq '' ? 20 : $::navi{"$name\_width"};
							$htmlbody.=<<EOD;
	<a title="@{[$::navi{"$name\_title"} eq '' ? $::navi{"$name\_name"} : $::navi{"$name\_title"}]}" href="$::navi{"$name\_url"}"><img alt="@{[$::navi{"$name\_title"} eq '' ? $::navi{"$name\_name"} : $::navi{"$name\_title"}]}" src="$image_url/$name.png" height="$height" width="$width" /></a>
EOD
						}
					}
				}
			}
		}
	}

	# lastmodifiedɽ
	$htmlbody.=<<EOD;
</div>
@{[ $::last_modified == 2
 ? qq(<div id="lastmodified">$::lastmod_prompt $lastmod</div>)
 : qq()
]}
<div id="footer">
EOD

	# ڡեå wikiʸˡ
	# lang=ja
	if($::lang eq 'ja') {
		$footerbody=<<EOD;
@{[$::wiki_title ne '' ? qq(''[[$::wiki_title>$basehref]]'' ) : '']}Modified by [[$::modifier>$::modifierlink]]~
~
''[[PyukiWiki $::version>http://pyukiwiki.sourceforge.jp/]]''
Copyright&copy; 2004-2006 by [[Nekyo>http://nekyo.hp.infoseek.co.jp/]], [[PyukiWiki Developers Team>http://pyukiwiki.sourceforge.jp/]]
License is [[GPL>http://www.opensource.jp/gpl/gpl.ja.html]], [[Artistic>http://www.opensource.jp/artistic/ja/Artistic-ja.html]]~
Based on "[[YukiWiki>http://www.hyuki.com/yukiwiki/]]" 2.1.0 by [[yuki>http://www.hyuki.com/]]
and [[PukiWiki>http://pukiwiki.sourceforge.jp/]] by [[PukiWiki Developers Term>http://pukiwiki.sourceforge.jp/]]~
EOD
	} else {
	# lang=en and/or other
		$footerbody=<<EOD;
@{[$::wiki_title ne '' ? qq(''[[$::wiki_title>$basehref]]'' ) : '']}Modified by [[$::modifier>$::modifierlink]]~
~
''[[PyukiWiki $::version>http://pyukiwiki.sourceforge.jp/en/]]''
Copyright&copy; 2004-2006 by [[Nekyo>http://nekyo.hp.infoseek.co.jp/]], [[PyukiWiki Developers Team>http://pyukiwiki.sourceforge.jp/en/]]
License is [[GPL>http://www.gnu.org/licenses/gpl.html]], [[Artistic>http://www.perl.com/language/misc/Artistic.html]]~
Based on "[[YukiWiki>http://www.hyuki.com/yukiwiki/]]" 2.1.0 by [[yuki>http://www.hyuki.com/]]
and [[PukiWiki>http://pukiwiki.sourceforge.jp/]] by [[PukiWiki Developers Term>http://pukiwiki.sourceforge.jp/]]~
EOD
	}
	$footerbody= &text_to_html($footerbody);
	$footerbody=~s/(<p>|<\/p>)//g;
	$htmlbody.= $footerbody;

	$htmlbody.= <<"EOD";
@{[&convtime]}
</div>

</div>
</div>
</body>
</html>
EOD
	return $htmlbody;
}

1;
